// unnamed package

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;


class Sheepdog
    extends Sprite
{
    static final int WIDTH = 15;
    static final int HEIGHT = 15;
    static final int VIBRATION_MILLIS = 200;

    private final SheepdogCanvas canvas;
    private boolean barking = false;
    private int[][][] animations = {{{0},                // stand up
                                     {1, 2, 3, 4}},      // run up
                                    {{5},                // stand left
                                     {6, 7, 8, 9}},      // run left
                                    {{10},               // stand down
                                     {11, 12, 13, 14}}}; // run down
    private int animationTick = 0;
    private static final int STAND = 0;
    private static final int RUN = 1;
    private int currentDirection = 16; // down
    private int currentDirection_big = 64;
    private int speed=0;
    public static final int MAX_SPEED=60;
    private int spx=10000;
    private int spy=10000;
    public static final int MAX_SP=500;

    Sheepdog(SheepdogCanvas canvas)
    {
        super(SheepdogMIDlet.createImage("/kaforgas2.png"), WIDTH, HEIGHT);
        defineCollisionRectangle(2, 2, WIDTH-4, WIDTH-4);
//        defineReferencePixel(0,0);
        defineReferencePixel(WIDTH/2, HEIGHT/2);

        this.canvas = canvas;
    }


    void tick(int direction, boolean bark)
    {
//        animationTick++;

        Field field = canvas.getField();
        boolean moving = false;
        if( speed >= 1 )
          speed -= 1;
        else
          speed = 0;
        int newX = (speed*myCos(currentDirection));
        int newY = (speed*mySin(currentDirection));

// up
//        if( currentDirection>=28 || currentDirection<=4 ) {
          if (!field.containsImpassableArea( ( (spx + newX) / MAX_SP)+getWidth()/2,
                                            ( (spy + newY) / MAX_SP)+getHeight()/2,
                                            getWidth(),
                                            1) &&
              moveSuccessfully(newX, newY)) {
            moving = true;
          } else {
            if( field.getElemXY(( (spx + newX) / MAX_SP)+getWidth()/2,
                                ( (spy + newY) / MAX_SP)+getHeight()/2) == 32 )
            {
              speed = 0;
              canvas.stop();
              canvas.getMidlet().stringScreen("Police Station","You are in the Police Station!");
            }
            if (speed >= 15)
              speed -= 15;
            else
              speed = 0;
        //  canvas.vibrate(VIBRATION_MILLIS);
          }
/*        } else
// down
        if( currentDirection>=12 && currentDirection<=20 ) {
          if (!field.containsImpassableArea( ( (spx + newX) / MAX_SP),
                                            ( (spy + newY) / MAX_SP)+ getHeight(),
                                            getWidth(),
                                            1) &&
              moveSuccessfully(newX, newY)) {
            moving = true;
          } else {
            if (speed >= 30)
              speed -= 30;
            else
              speed = 0;
        //  canvas.vibrate(VIBRATION_MILLIS);
          }
        } else
// left
        if( currentDirection>=4 && currentDirection<=12 ) {
          if (!field.containsImpassableArea( ( (spx + newX) / MAX_SP),
                                            ( (spy + newY) / MAX_SP),
                                            1,
                                            getHeight()) &&
              moveSuccessfully(newX, newY)) {
            moving = true;
          } else {
            if (speed >= 30)
              speed -= 30;
            else
              speed = 0;
        //  canvas.vibrate(VIBRATION_MILLIS);
          }
        } else
// right
        if( currentDirection>=4 && currentDirection<=12 ) {
          if (!field.containsImpassableArea( ( (spx + newX) / MAX_SP) + getWidth(),
                                            ( (spy + newY) / MAX_SP),
                                            1,
                                            getHeight()) &&
              moveSuccessfully(newX, newY)) {
            moving = true;
          } else {
            if (speed >= 30)
              speed -= 30;
            else
              speed = 0;
        //  canvas.vibrate(VIBRATION_MILLIS);
          }
        }
*/


/*        switch (direction)
        {
        case SheepdogCanvas.UP:
            currentDirection = direction;
            if ((getY() > 0) &&
                !field.containsImpassableArea(getX(),
                                              getY() - 1,
                                              getWidth(),
                                              1) &&
                moveSuccessfully(0, -1))
            {
                moving = true;
            }
            else
            {
                canvas.vibrate(VIBRATION_MILLIS);
            }
            break;
        case SheepdogCanvas.LEFT:
            currentDirection = direction;
            if ((getX() > 0) &&
                !field.containsImpassableArea(getX() - 1,
                                              getY(),
                                              1,
                                              getHeight()) &&
                moveSuccessfully(-1, 0))
            {
                moving = true;
            }
            else
            {
                canvas.vibrate(VIBRATION_MILLIS);
            }
            break;
        case SheepdogCanvas.DOWN:
            currentDirection = direction;
            if ((getY() + getHeight() < field.getWidth()) &&
                !field.containsImpassableArea(getX(),
                                              getY() + getHeight(),
                                              getWidth(),
                                              1) &&
                moveSuccessfully(0, 1))
            {
                moving = true;
            }
            else
            {
                canvas.vibrate(VIBRATION_MILLIS);
            }
            break;
        case SheepdogCanvas.RIGHT:
            currentDirection = direction;
            if ((getX() + getWidth() < field.getWidth()) &&
                !field.containsImpassableArea(getX() + getWidth(),
                                              getY(),
                                              1,
                                              getHeight()) &&
                moveSuccessfully(1, 0))
            {
                moving = true;
            }
            else
            {
                canvas.vibrate(VIBRATION_MILLIS);
            }
            break;
        default:  // must be NONE
            break;
        }
*/

//        if (moving)
//        {
//            advanceRunningAnimation();
//        }
//        else
//        {
            setStandingAnimation();
//        }

        // implement a toggle, so bark only happens once per click
        // (will therefore not register very rapid multiple-clicks)
        if (bark)
        {
            if (!barking)
            {
                SoundEffects.getInstance().startDogSound();
                barking = true;
            }
        }
        else
        {
            barking = false;
        }
    }


    private boolean moveSuccessfully(int dx, int dy)
    {
      spx += dx;
      spy += dy;

      setPosition(spx/MAX_SP,spy/MAX_SP);
//        move(dx, dy);
        if (canvas.overlapsSheep(this))
        {
          spx -= dx;
          spy -= dy;

          setPosition(spx/MAX_SP,spy/MAX_SP);
  //          move(-dx, -dy);
            return false;
        }
        else
        {
            return true;
        }
    }

    private void setStandingAnimation()
    {
        if (currentDirection >= 17)
        {
            setFrame((32-currentDirection)%17);
            setTransform(TRANS_MIRROR);
        }
        else
        {
            setFrame(currentDirection%17);
            setTransform(TRANS_NONE);
        }
    }

    public void right() {
      if( currentDirection_big > 0 )
        currentDirection_big--;
      else
        currentDirection_big=127;
      currentDirection=currentDirection_big/4;
    }

    public void left() {
      if( currentDirection_big < 127 )
        currentDirection_big++;
      else
        currentDirection_big=0;
      currentDirection=currentDirection_big/4;
    }

    public void speedUp() {
      if( speed < MAX_SPEED )
        speed += 3;
    }

    public void speedDown() {
      if( speed >=6 ) speed -= 6;
      else speed=0;
    }

    public static int myCos( int direction ) {
      direction %= 32;
      switch (direction)
      {
        case 0: return 0;
        case 1: return -2;
        case 2: return -4;
        case 3: return -6;
        case 4: return -7;
        case 5: return -8;
        case 6: return -9;
        case 7: return -9;
        case 8: return -10;
        case 9: return -9;
        case 10: return -9;
        case 11: return -8;
        case 12: return -7;
        case 13: return -6;
        case 14: return -4;
        case 15: return -2;
        case 16: return 0;
        case 17: return 2;
        case 18: return 4;
        case 19: return 6;
        case 20: return 7;
        case 21: return 8;
        case 22: return 9;
        case 23: return 9;
        case 24: return 10;
        case 25: return 9;
        case 26: return 9;
        case 27: return 8;
        case 28: return 7;
        case 29: return 6;
        case 30: return 4;
        case 31: return 2;
        default:
          return 0;
      }
    }

    public static int mySin( int direction ) {
      direction %= 32;

      switch (direction)
      {
        case 0: return -10;
        case 1: return -9;
        case 2: return -9;
        case 3: return -8;
        case 4: return -7;
        case 5: return -6;
        case 6: return -4;
        case 7: return -2;
        case 8: return 0;
        case 9: return 2;
        case 10: return 4;
        case 11: return 6;
        case 12: return 7;
        case 13: return 8;
        case 14: return 9;
        case 15: return 9;
        case 16: return 10;
        case 17: return 9;
        case 18: return 9;
        case 19: return 8;
        case 20: return 7;
        case 21: return 6;
        case 22: return 4;
        case 23: return 2;
        case 24: return 0;
        case 25: return -2;
        case 26: return -4;
        case 27: return -6;
        case 28: return -7;
        case 29: return -8;
        case 30: return -9;
        case 31: return -9;
        default:
          return -10;
      }
    }
    public int getCDirection() {return currentDirection;}
    public int getSpeed() {return speed;}

}
